/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package controller;

import com.sun.xml.ws.transport.tcp.server.glassfish.ServletFakeArtifactSet;
import entity.Customer;
import entity.CustomerOrder;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import javax.servlet.RequestDispatcher;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.ServletOutputStream;
import javax.servlet.ServletInputStream;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;
import static org.mockito.Mockito.*;
import session.CustomerFacade;
import session.CustomerOrderFacade;

/**
 *
 * @author User
 */
public class AdminServletTest {
    
    public AdminServletTest() {
    }
    
    @BeforeClass
    public static void setUpClass() {
    }
    
    @AfterClass
    public static void tearDownClass() {
    }
    
    @Before
    public void setUp() {
    }
    
    @After
    public void tearDown() {
    }

    /**
     * Test of processRequest method, of class AdminServlet.
     */
    @Test
    public void testWhenNavigateToViewCustomersAttributeIsSet() throws Exception {
        System.out.println("processRequest");
        
        // given
        final String PATH_REQUESTED = "/admin/viewCustomers";

        /// priprema zavisnih objekata - ovo su LAZNI objekti
        HttpServletRequest mockedRequest = mock(HttpServletRequest.class);
        when(mockedRequest.getServletPath()).thenReturn(PATH_REQUESTED);
        RequestDispatcher mockedRequestDispatcher = mock(RequestDispatcher.class);
        when(mockedRequest.getRequestDispatcher(anyString())).thenReturn(mockedRequestDispatcher);
        
        HttpServletResponse mockedResponse = mock(HttpServletResponse.class);
        
        
        // klasa CustomerFacade se mock-uje
        CustomerFacade mockedCustomerFacade = mock(CustomerFacade.class);
        Customer[] customers = { new Customer() };
        List<Customer> customerList = Arrays.asList(customers);
        when(mockedCustomerFacade.findAll()).thenReturn(customerList);
        
        /// priprema objekta koji se testira - ovo je PRAVI objekat
        AdminServlet adminServlet = new AdminServlet();
        adminServlet.customerFacade = mockedCustomerFacade;
        
        // when
        adminServlet.processRequest(mockedRequest, mockedResponse);
        
        // then
        verify(mockedRequest).setAttribute("customerList", customerList);
    }
    
    
    @Test
    public void testWhenNavigateToViewOrdersAttributeIsSet() throws Exception {
        System.out.println("processRequest");
        
        // given
        final String PATH_REQUESTED = "/admin/viewOrders";

        /// priprema zavisnih objekata - ovo su LAZNI objekti
        HttpServletRequest mockedRequest = mock(HttpServletRequest.class);
        when(mockedRequest.getServletPath()).thenReturn(PATH_REQUESTED);
        RequestDispatcher mockedRequestDispatcher = mock(RequestDispatcher.class);
        
        // requestDispatcher nije mock-ovan zbog semantike testa vec zbog NPE koji se desava
        // i da nije mock-ovano ne utice na test
        when(mockedRequest.getRequestDispatcher(anyString())).thenReturn(mockedRequestDispatcher); 
        HttpServletResponse mockedResponse = mock(HttpServletResponse.class);
        
        // klasa CustomerOrderFacade se mock-uje
        CustomerOrderFacade mockedFacade = mock(CustomerOrderFacade.class);
        List<CustomerOrder> orderList = new ArrayList<CustomerOrder>();
        when(mockedFacade.findAll()).thenReturn(orderList);
        
        /// priprema objekta koji se testira - ovo je PRAVI objekat
        AdminServlet adminServlet = new AdminServlet();
        adminServlet.customerOrderFacade = mockedFacade;
        
        
        // when
        adminServlet.processRequest(mockedRequest, mockedResponse);
        
        
        // then
        verify(mockedRequest).setAttribute("orderList", orderList);
        verify(mockedRequest, never()).setAttribute("customerList", null);
    }
    
    /**
     * Test of doGet method, of class AdminServlet.
     */
    @Test
    public void testDoGet() throws Exception {
        System.out.println("doGet");        
        HttpServletRequest request = new ServletFakeArtifactSet.FakeServletHttpRequest("requestURL", "servletPath");
        HttpServletResponse response = new ServletFakeArtifactSet.FakeServletHttpResponse();
        AdminServlet instance = new AdminServlet();
        instance.doGet(request, response);
    }

    /**
     * Test of doPost method, of class AdminServlet.
     */
    @Test
    public void testDoPost() throws Exception {
        System.out.println("doPost");
        HttpServletRequest request = new ServletFakeArtifactSet.FakeServletHttpRequest("requestURL", "servletPath");
        HttpServletResponse response = new ServletFakeArtifactSet.FakeServletHttpResponse();
        AdminServlet instance = new AdminServlet();
        instance.doPost(request, response);
    }
   
    
}
