/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package controller;

import cart.ShoppingCart;
import com.sun.xml.ws.transport.tcp.server.glassfish.ServletFakeArtifactSet;
import entity.Customer;
import entity.CustomerOrder;
import entity.OrderedProduct;
import entity.Product;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;
import javax.persistence.EntityManager;
import javax.persistence.TypedQuery;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.servlet.RequestDispatcher;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletRequestWrapper;
import javax.servlet.http.HttpServletResponse;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;
import static org.mockito.Mockito.*;
import session.CustomerFacade;
import session.CustomerOrderFacade;
import session.OrderManager;
import session.OrderedProductFacade;
import session.ProductFacade;

/**
 *
 * @author User
 */
public class AdminServletTopDownITLevel1Phase1 {
    
    public AdminServletTopDownITLevel1Phase1() {
    }
    
    @BeforeClass
    public static void setUpClass() {
    }
    
    @AfterClass
    public static void tearDownClass() {
    }
    
    @Before
    public void setUp() {
    }
    
    @After
    public void tearDown() {
    }

    /**
     * Test of processRequest method, of class AdminServlet.
     */
    @Test
    public void testProcessRequestViewCustomers() throws Exception {
        // given
        // top komponenta L1
        AdminServlet adminServlet = new AdminServlet();
        // komponente L2
        OrderManager orderManager = new OrderManager();
        CustomerFacade customerFacade = new CustomerFacade();
        // povezujemo
        adminServlet.orderManager = orderManager;
        adminServlet.customerFacade = customerFacade;
        // ostale komponente mokujemo
        // prvo za AdminServlet
        CustomerOrderFacade cofMock = mock(CustomerOrderFacade.class);
        adminServlet.customerOrderFacade = cofMock;
        // zatim za OrderManager
        OrderedProductFacade opfMock = mock(OrderedProductFacade.class);
        ProductFacade pfMock = mock(ProductFacade.class);
        orderManager.orderedProductFacade = opfMock;
        orderManager.customerOrderFacade = cofMock;
        orderManager.productFacade = pfMock;
        // zatim za CustomerFacade
        /// u ovom scenariju se poziva findAll(), pa treba mock-ovati
        /// sve iz findAll metode
        Customer[] customers = { 
                new Customer(1, "Ime Prezime", "imeprezime@gmail.com", "011 111-111", "Bulevar 11", "Beograd", null),
                new Customer(2, "Prezime Ime", "imeprez@gmail.com", "011 111-111", "Bulevar 22", "Beograd", null)
        };
        List<Customer> customerList = Arrays.asList(customers);
        EntityManager emMock = mock(EntityManager.class);
        CriteriaBuilder cbMock = mock(CriteriaBuilder.class);
        CriteriaQuery cqMock = mock(CriteriaQuery.class);
        TypedQuery tqMock = mock(TypedQuery.class);
        when(emMock.getCriteriaBuilder()).thenReturn(cbMock);
        when(cbMock.createQuery()).thenReturn(cqMock);
        when(emMock.createQuery(cqMock)).thenReturn(tqMock);
        when(tqMock.getResultList()).thenReturn(customerList);
        customerFacade.em = emMock;
        
        /// priprema zavisnih objekata koji nisu nasi moduli
        
        final String PATH_REQUESTED = "/admin/viewCustomers";
        HttpServletRequest mockedRequest = mock(HttpServletRequest.class);
        when(mockedRequest.getServletPath()).thenReturn(PATH_REQUESTED);
        RequestDispatcher mockedRequestDispatcher = mock(RequestDispatcher.class);
        when(mockedRequest.getRequestDispatcher(anyString())).thenReturn(mockedRequestDispatcher);
        
        HttpServletResponse mockedResponse = mock(HttpServletResponse.class);
        
        // when
        adminServlet.processRequest(mockedRequest, mockedResponse);
        
        // then
        verify(mockedRequest).setAttribute("customerList", customerList);
        
    }

    @Test
    public void testProcessRequestCustomerRecord() throws Exception {
        // given
        // top komponenta L1
        AdminServlet adminServlet = new AdminServlet();
        // komponente L2
        OrderManager orderManager = new OrderManager();
        CustomerFacade customerFacade = new CustomerFacade();
        // povezujemo
        adminServlet.orderManager = orderManager;
        adminServlet.customerFacade = customerFacade;
        // ostale komponente mokujemo
        // prvo za AdminServlet
        CustomerOrderFacade cofMock = mock(CustomerOrderFacade.class);
        adminServlet.customerOrderFacade = cofMock;
        // zatim za OrderManager
        OrderedProductFacade opfMock = mock(OrderedProductFacade.class);
        ProductFacade pfMock = mock(ProductFacade.class);
        orderManager.orderedProductFacade = opfMock;
        orderManager.customerOrderFacade = cofMock;
        orderManager.productFacade = pfMock;
        // zatim za CustomerFacade
        /// u ovom scenariju se poziva find
        Customer customer = 
                new Customer(1, "Ime Prezime", "imepreyime@gmail.com", "011 111-111", "Bulevar 11", "Beograd", null);
        CustomerOrder order = new CustomerOrder(200, new BigDecimal(1500.55), new Date(), 200);
        
        EntityManager emMock = mock(EntityManager.class);
        when(emMock.find(Customer.class, new Integer(1))).thenReturn(customer);
        customerFacade.em = emMock;
        // zatim za CustomerOrderFacade
        // ovo je malo jednostavnije jer je CustomerOrderFacade mock
        when(cofMock.findByCustomer(customer)).thenReturn(order);
        
        /// priprema zavisnih objekata koji nisu nasi moduli
        
        final String PATH_REQUESTED = "/admin/customerRecord";
        HttpServletRequest mockedRequest = mock(HttpServletRequest.class);
        when(mockedRequest.getServletPath()).thenReturn(PATH_REQUESTED);
        when(mockedRequest.getQueryString()).thenReturn("1");
        RequestDispatcher mockedRequestDispatcher = mock(RequestDispatcher.class);
        when(mockedRequest.getRequestDispatcher(anyString())).thenReturn(mockedRequestDispatcher);
        
        HttpServletResponse mockedResponse = mock(HttpServletResponse.class);
        
        // when
        adminServlet.processRequest(mockedRequest, mockedResponse);
        
        // then
        verify(mockedRequest).setAttribute("customerRecord", customer);
        verify(mockedRequest).setAttribute("order", order);

    }
    
    @Test
    public void testProcessRequestOrderRecord() throws Exception {
        // given
        // top komponenta L1
        AdminServlet adminServlet = new AdminServlet();
        // komponente L2
        OrderManager orderManager = new OrderManager();
        CustomerFacade customerFacade = new CustomerFacade();
        // povezujemo
        adminServlet.orderManager = orderManager;
        adminServlet.customerFacade = customerFacade;
        // ostale komponente mokujemo
        // prvo za AdminServlet
        CustomerOrderFacade cofMock = mock(CustomerOrderFacade.class);
        adminServlet.customerOrderFacade = cofMock;
        // zatim za OrderManager
        OrderedProductFacade opfMock = mock(OrderedProductFacade.class);
        ProductFacade pfMock = mock(ProductFacade.class);
        orderManager.orderedProductFacade = opfMock;
        orderManager.customerOrderFacade = cofMock;
        orderManager.productFacade = pfMock;
        // zatim za CustomerFacade
        // zatim za OrderManager
        // u ovom scenariju poziva se getOrderDetails(int orderId)
        Customer customer = 
                new Customer(1, "Ime Prezime", "imeprezime@gmail.com", "011 111-111", "Bulevar 11", "Beograd", null);
        CustomerOrder order = new CustomerOrder(200, new BigDecimal(1500.55), new Date(), 200);
        order.setCustomer(customer);
        final ArrayList<OrderedProduct> orderedProducts = new ArrayList<OrderedProduct>();

        orderManager.customerOrderFacade = cofMock;
        when(cofMock.find(200)).thenReturn(order);
        // sad se poziva    List<OrderedProduct> orderedProducts = orderedProductFacade.findByOrderId(orderId);
        when(opfMock.findByOrderId(200)).thenReturn(orderedProducts);
        
        /// priprema zavisnih objekata koji nisu nasi moduli
        final String PATH_REQUESTED = "/admin/orderRecord";
        HttpServletRequest mockedRequest = mock(HttpServletRequest.class);
        when(mockedRequest.getServletPath()).thenReturn(PATH_REQUESTED);
        when(mockedRequest.getQueryString()).thenReturn("200");
        RequestDispatcher mockedRequestDispatcher = mock(RequestDispatcher.class);
        when(mockedRequest.getRequestDispatcher(anyString())).thenReturn(mockedRequestDispatcher);
        
        HttpServletResponse mockedResponse = mock(HttpServletResponse.class);
        
        // when
        adminServlet.processRequest(mockedRequest, mockedResponse);
        
        // then
        verify(mockedRequest).setAttribute("customer", customer);
        verify(mockedRequest).setAttribute("products", new ArrayList<Product>());
        verify(mockedRequest).setAttribute("orderRecord", order);
        verify(mockedRequest).setAttribute("orderedProducts", orderedProducts);
    }
    
    /**
     * Test of doGet method, of class AdminServlet.
     */
    @Test
    public void testDoGet() throws Exception {
        System.out.println("doGet");        
        HttpServletRequest request = new ServletFakeArtifactSet.FakeServletHttpRequest("requestURL", "servletPath");
        HttpServletResponse response = new ServletFakeArtifactSet.FakeServletHttpResponse();
        AdminServlet instance = new AdminServlet();
        instance.doGet(request, response);
    }

    /**
     * Test of doPost method, of class AdminServlet.
     */
    @Test
    public void testDoPost() throws Exception {
        System.out.println("doPost");
        HttpServletRequest request = new ServletFakeArtifactSet.FakeServletHttpRequest("requestURL", "servletPath");
        HttpServletResponse response = new ServletFakeArtifactSet.FakeServletHttpResponse();
        AdminServlet instance = new AdminServlet();
        instance.doPost(request, response);
    }
    
}
