/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package controller;

import com.sun.xml.ws.transport.tcp.server.glassfish.ServletFakeArtifactSet;
import entity.Customer;
import entity.CustomerOrder;
import entity.OrderedProduct;
import entity.Product;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;
import javax.persistence.EntityManager;
import javax.persistence.Query;
import javax.persistence.TypedQuery;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.servlet.RequestDispatcher;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;
import static org.mockito.Mockito.*;
import session.CustomerFacade;
import session.CustomerOrderFacade;
import session.OrderManager;
import session.OrderedProductFacade;
import session.ProductFacade;

/**
 * CustomerOrderFacade je sada pravi u fazi 2, za razliku od faze 1
 * kada je bio mock
 *   
 * @author User
 */
public class AdminServletTopDownITLevel2Phase1 {
    
    public AdminServletTopDownITLevel2Phase1() {
    }
    
    @BeforeClass
    public static void setUpClass() {
    }
    
    @AfterClass
    public static void tearDownClass() {
    }
    
    @Before
    public void setUp() {
    }
    
    @After
    public void tearDown() {
    }
    
    @Test
    public void testProcessRequestOrderRecord() throws Exception {
        // given
        // top komponenta L1
        AdminServlet adminServlet = new AdminServlet();
        // komponente L2
        OrderManager orderManager = new OrderManager();
        CustomerFacade customerFacade = new CustomerFacade();
        CustomerOrderFacade customerOrderFacade = new CustomerOrderFacade();
        OrderedProductFacade orderedProductFacade = new OrderedProductFacade();
        
        // povezujemo
        adminServlet.orderManager = orderManager;
        adminServlet.customerFacade = customerFacade;
        adminServlet.customerOrderFacade = customerOrderFacade;
        
        orderManager.customerOrderFacade = customerOrderFacade;
        orderManager.orderedProductFacade = orderedProductFacade;
        
        // ostale komponente mokujemo
        // za OrderManager

        ProductFacade pfMock = mock(ProductFacade.class);
        
        orderManager.productFacade = pfMock;
        // zatim za CustomerFacade
        // zatim za OrderManager
        // u ovom scenariju poziva se getOrderDetails(int orderId)
        Customer customer = 
                new Customer(1, "Ime Prezime", "imeprezime@gmail.com", "011 111-111", "Bulevar 11", "Beograd", null);
        CustomerOrder order = new CustomerOrder(200, new BigDecimal(1500.55), new Date(), 200);
        order.setCustomer(customer);
        final ArrayList<OrderedProduct> orderedProducts = new ArrayList<OrderedProduct>();
        
        // poziva se CustomerOrder order = customerOrderFacade.find(orderId);
        // find poziva EntityManager, pa to moramo da mockujemo
        EntityManager emMock = mock(EntityManager.class);
        when(emMock.find(CustomerOrder.class, new Integer(200))).thenReturn(order);
        customerOrderFacade.em = emMock;
        
        // poziva se    List<OrderedProduct> orderedProducts = orderedProductFacade.findByOrderId(orderId);
        // unutar te metode poziva se 
        // em.createNamedQuery("OrderedProduct.findByCustomerOrderId")
        //      .setParameter("customerOrderId", id)
        //      .getResultList();
        Query qMock = mock(Query.class);
        when(emMock.createNamedQuery("OrderedProduct.findByCustomerOrderId")).thenReturn(qMock);
        when(qMock.setParameter("customerOrderId", new Integer(200))).thenReturn(qMock);
        when(qMock.getResultList()).thenReturn(orderedProducts);
        orderedProductFacade.em = emMock;
        
        /// priprema zavisnih objekata koji nisu nasi moduli
        final String PATH_REQUESTED = "/admin/orderRecord";
        HttpServletRequest mockedRequest = mock(HttpServletRequest.class);
        when(mockedRequest.getServletPath()).thenReturn(PATH_REQUESTED);
        when(mockedRequest.getQueryString()).thenReturn("200");
        RequestDispatcher mockedRequestDispatcher = mock(RequestDispatcher.class);
        when(mockedRequest.getRequestDispatcher(anyString())).thenReturn(mockedRequestDispatcher);
        
        HttpServletResponse mockedResponse = mock(HttpServletResponse.class);
        
        // when
        adminServlet.processRequest(mockedRequest, mockedResponse);
        
        // then
        verify(mockedRequest).setAttribute("customer", customer);
        verify(mockedRequest).setAttribute("products", new ArrayList<Product>());
        verify(mockedRequest).setAttribute("orderRecord", order);
        verify(mockedRequest).setAttribute("orderedProducts", orderedProducts);
    }
    
    
    /**
     * Test of doGet method, of class AdminServlet.
     */
    @Test
    public void testDoGet() throws Exception {
        System.out.println("doGet");        
        HttpServletRequest request = new ServletFakeArtifactSet.FakeServletHttpRequest("requestURL", "servletPath");
        HttpServletResponse response = new ServletFakeArtifactSet.FakeServletHttpResponse();
        AdminServlet instance = new AdminServlet();
        instance.doGet(request, response);
    }

    /**
     * Test of doPost method, of class AdminServlet.
     */
    @Test
    public void testDoPost() throws Exception {
        System.out.println("doPost");
        HttpServletRequest request = new ServletFakeArtifactSet.FakeServletHttpRequest("requestURL", "servletPath");
        HttpServletResponse response = new ServletFakeArtifactSet.FakeServletHttpResponse();
        AdminServlet instance = new AdminServlet();
        instance.doPost(request, response);
    }

    
}
