/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package controller;

import entity.Category;
import entity.Customer;
import entity.Product;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;
import javax.persistence.EntityManager;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;
import static org.mockito.Matchers.anyString;
import static org.mockito.Mockito.mock;
import static org.mockito.Mockito.verify;
import static org.mockito.Mockito.when;
import session.CategoryFacade;
import session.CustomerFacade;

/**
 *
 * @author User
 */
public class ControllerServletTest {
    
    public ControllerServletTest() {
    }
    
    @BeforeClass
    public static void setUpClass() {
    }
    
    @AfterClass
    public static void tearDownClass() {
    }
    
    @Before
    public void setUp() {
    }
    
    @After
    public void tearDown() {
    }

    /**
     * Test of init method, of class ControllerServlet.
     */
    @Test
    public void testInit() throws Exception {
        //given
       
        // init prvo postavi surcharge
        // surcharge = servletConfig.getServletContext().getInitParameter("deliverySurcharge")
        ServletConfig mockedServletConfig = mock(ServletConfig.class);
        ServletContext mockedServletContext = mock(ServletContext.class);
        when(mockedServletConfig.getServletContext()).thenReturn(mockedServletContext);
        when(mockedServletContext.getInitParameter("deliverySurcharge")).thenReturn("15");
        
        // slecece init ucita sve Kategorije
        // getServletContext().setAttribute("categories", categoryFacade.findAll());
        // mockujemo CategoryFacade
        CategoryFacade mockedCategoryFacade = mock(CategoryFacade.class);
        Category[] categories = { new Category((short)1, "books"), new Category((short)2, "toys"),
            new Category((short)3, "vegetables"), new Category((short)4, "fruit")};
        final List<Category> categoryList = Arrays.asList(categories);
        when(mockedCategoryFacade.findAll()).thenReturn(categoryList);
        
        ControllerServlet controllerServlet = new ControllerServlet();
        controllerServlet.categoryFacade = mockedCategoryFacade;

        
        //when
        controllerServlet.init(mockedServletConfig);
        
        //then
        assertEquals("15", controllerServlet.getSurcharge());
        verify(mockedServletContext).setAttribute("categories", categoryList);
    }

    /**
     * Test of doGet method, of class AdminServlet.
     */
    @Test
    public void testDoGetCategory() throws Exception {
        //given
        HttpServletRequest mockedRequest = mock(HttpServletRequest.class);
        RequestDispatcher mockedRequestDispatcher = mock(RequestDispatcher.class);
        HttpSession mockedHttpSession = mock(HttpSession.class);
        when(mockedRequest.getRequestDispatcher(anyString())).thenReturn(mockedRequestDispatcher);
        when(mockedRequest.getServletPath()).thenReturn("/category");
        when(mockedRequest.getQueryString()).thenReturn("1");
        when(mockedRequest.getSession()).thenReturn(mockedHttpSession);
        
        // napravimo kategoriju sa nesto proizvoda
        Category booksCategory = new Category((short)1, "books");
        Product gofBook = new Product(1, "Programming Patterns", new BigDecimal(100), new Date());
        Product testingBook = new Product(2, "Testing Best Practices", new BigDecimal(200), new Date());
        Product agileBook = new Product(3, "Agile and Scrum revisited", new BigDecimal(300), new Date());
        List<Product> books = new ArrayList<Product>();
        books.add(gofBook);
        books.add(testingBook);
        books.add(agileBook);
        booksCategory.setProductCollection(books);
        
        // CategoryFacade je pravi, pa moramo da mock-ujemo unutar njega
        CategoryFacade categoryFacade = new CategoryFacade();
        // zove se entityManager#find pa mora da se mockuje entityManager
        EntityManager mockedEm = mock(EntityManager.class);
        when(mockedEm.find(Category.class, (short)1)).thenReturn(booksCategory);
        categoryFacade.em = mockedEm;
        
        HttpServletResponse mockedResponse = mock(HttpServletResponse.class);
        
        ControllerServlet controllerServlet = new ControllerServlet();
        controllerServlet.categoryFacade = categoryFacade;
        
        //when
        controllerServlet.doGet(mockedRequest, mockedResponse);
        
        //then
        verify(mockedHttpSession).setAttribute("selectedCategory", booksCategory);
        verify(mockedHttpSession).setAttribute("categoryProducts", books);
        
    }

}
