import static org.junit.Assert.*;

import java.io.IOException;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

public class CheckAddedCartItemTest {

	private AffableBeanWebUI webUI;

	/**
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception {
		webUI = new AffableBeanWebUI();
	}
	
	/**
	 * @throws java.lang.Exception
	 */
	@After
	public void tearDown() throws Exception {
		webUI.dispose();
	}

	@Test
	public void CheckAddedDairyItemTest() throws IOException {
		
		webUI.getWelcomePage().chooseDairy();
		webUI.getCategoryPage().addItemToCart(0);
		
		webUI.getCategoryPage().viewCart();
		
		String imgAtr = webUI.getCartPage().getFirstProductImageAltAttribute();
		
		// BufferedImage originalImage = ImageIO.read(new File("D:/diplomski/AffableBean/web/img/products/milk.png"));
		
		//		try {
		//			wait(1000);
		//		} catch (InterruptedException e) {
		//			// TODO Auto-generated catch block
		//			e.printStackTrace();
		//		}
		
		//assertEquals(originalImage, webElement);
		
		assertEquals("milk", imgAtr);
	}
	
	@Test
	public void CheckAddedBakeryItemTest() {
		
		webUI.getWelcomePage().chooseBakery();
		webUI.getCategoryPage().addItemToCart(0);
		
		webUI.getCategoryPage().viewCart();

		String imgAtr = webUI.getCartPage().getFirstProductImageAltAttribute();
		
		assertEquals("sunflower seed loaf", imgAtr);
	}
	
	@Test
	public void CheckAddedMeatsItemTest() {
		
		webUI.getWelcomePage().chooseMeats();
		webUI.getCategoryPage().addItemToCart(0);
		
		webUI.getCategoryPage().viewCart();
		
		String imgAtr = webUI.getCartPage().getFirstProductImageAltAttribute();
		
		assertEquals("organic meat patties", imgAtr);
	}
	
	@Test
	public void CheckAddedFruitAndVegItemTest() {
		
		webUI.getWelcomePage().chooseFruitAndVeg();
		webUI.getCategoryPage().addItemToCart(0);
		
		webUI.getCategoryPage().viewCart();
		
		String imgAtr = webUI.getCartPage().getFirstProductImageAltAttribute();
		
		assertEquals("corn on the cob", imgAtr);
	}


}
